package gpjocl;

import static com.jogamp.opencl.CLMemory.Mem.READ_ONLY;
import static com.jogamp.opencl.CLMemory.Mem.WRITE_ONLY;
import static java.lang.Math.min;
import static java.lang.System.nanoTime;
import static java.lang.System.out;
import gpjocl.GACanvas.Chromosome;

import java.io.IOException;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.util.Random;

import com.jogamp.opencl.CLBuffer;
import com.jogamp.opencl.CLCommandQueue;
import com.jogamp.opencl.CLContext;
import com.jogamp.opencl.CLDevice;
import com.jogamp.opencl.CLKernel;
import com.jogamp.opencl.CLProgram;

public class test2 {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		Chromosome[] kromici = new Chromosome[5];
		kromici[0]=new Chromosome();
		kromici[1]=new Chromosome();
		kromici[2]=new Chromosome();
		kromici[3]=new Chromosome();
		kromici[4]=new Chromosome();
		
		kromici[0].randomize();
		kromici[1].randomize();
		kromici[2].randomize();
		kromici[3].randomize();
		kromici[4].randomize();
		
		
		System.out.println("cvel "+kromici[0].velicina);
		for (int i=0;i<20;i++)
			System.out.print(kromici[0].stablo[i]+" ");
		
		System.out.println();
		for (int i=0;i<20;i++)
			System.out.print(kromici[1].stablo[i]+" ");
		
		System.out.println();
		for (int i=0;i<20;i++)
			System.out.print(kromici[2].stablo[i]+" ");
		
		System.out.println();
		for (int i=0;i<20;i++)
			System.out.print(kromici[3].stablo[i]+" ");
		
		System.out.println();
		for (int i=0;i<20;i++)
			System.out.print(kromici[4].stablo[i]+" ");
		
		
		System.out.println();
		// set up (uses default CLPlatform and creates context for all devices)
        CLContext context = CLContext.create();
        System.out.println("created "+context);
		
        try{
            
            // select fastest device
            CLDevice device = context.getMaxFlopsDevice();
            System.out.println("using "+device);

            // create command queue on device.
            CLCommandQueue queue = device.createCommandQueue();

            int elementCount = 5;                                  // Length of arrays to process
            int localWorkSize = min(device.getMaxWorkGroupSize(), 256);  // Local work size dimensions
            
            int globalWorkSize = roundUp(localWorkSize, elementCount);   // rounded up to the nearest multiple of the localWorkSize
            
            out.println("ovaj localwork: "+localWorkSize);
            out.println("ovaj getmaxwork: "+device.getMaxWorkGroupSize());
            // load sources, create and build program
            CLProgram program = context.createProgram(test2.class.getResourceAsStream("Test.cl")).build();

            // A, B are input buffers, C is for the result
            CLBuffer<IntBuffer> clBufferA = context.createIntBuffer(globalWorkSize, READ_ONLY);
            CLBuffer<IntBuffer> clBufferB = context.createIntBuffer(globalWorkSize, READ_ONLY);
            CLBuffer<IntBuffer> clBufferC = context.createIntBuffer(globalWorkSize, WRITE_ONLY);
            
            out.println("used device memory: "
                + (clBufferA.getCLSize()+clBufferB.getCLSize()+clBufferC.getCLSize())/1000000 +"MB");

            // fill input buffers with random numbers
            // (just to have test data; seed is fixed -> results will not change between runs).
            Random rand= new Random();
            int k=0;
            for (k=0;k<5;k++)
            	clBufferA.getBuffer().put( (rand.nextInt(4)*10+rand.nextInt(4)));
            clBufferA.getBuffer().rewind();
            
            
            out.println(clBufferB.getBuffer().remaining());
            for (k=0;k<5;k++){
            	
            	for (int i=0;i<20;i++)
            	clBufferB.getBuffer().put((kromici[k].stablo[i]));
            	
            }
            clBufferB.getBuffer().rewind();
            
            // get a reference to the kernel function with the name 'VectorAdd'
            // and map the buffers to its input parameters.
            CLKernel kernel = program.createCLKernel("Test");
            kernel.putArgs(clBufferA, clBufferB, clBufferC).putArg(elementCount);
            
            
        //    out.println("prvi: "+clBufferA.getBuffer().get());
         //   out.println("drugi: "+clBufferB.getBuffer().get());
            // asynchronous write of data to GPU device,
            // followed by blocking read to get the computed results back.
            long time = nanoTime();
            queue.putWriteBuffer(clBufferA, false)
                 .putWriteBuffer(clBufferB, false)
                 .put1DRangeKernel(kernel, 0, globalWorkSize, localWorkSize)
                 .putReadBuffer(clBufferC, true);
            time = nanoTime() - time;

            // print first few elements of the resulting buffer to the console.
            out.println("a+b=c results snapshot: ");
            for(int i = 0; i < 10; i++)
                out.print(clBufferC.getBuffer().get() + ", ");
            out.println("...; " + clBufferC.getBuffer().remaining() + " more");

            out.println("computation took: "+(time/1000000)+"ms");
            
        }finally{
            // cleanup all resources associated with this context.
            context.release();
        }
	}
	private static void fillBuffer(FloatBuffer buffer, int seed) {
        Random rnd = new Random(seed);
        while(buffer.remaining() != 0)
            buffer.put(rnd.nextFloat()*100);
        buffer.rewind();
    }

    private static int roundUp(int groupSize, int globalSize) {
        int r = globalSize % groupSize;
        if (r == 0) {
            return globalSize;
        } else {
            return globalSize + groupSize - r;
        }
    }
    
    
    
    
}

